<?php

namespace lib\Helpers;

use lib\Core\Helper as Core;

abstract class CommonHelper extends Core
{
  public function __construct()
  {
    parent::__construct();
  } //


  final public function getRandomString($length = 10, $characters = "abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ0123456789")
  {
    return substr(str_shuffle($characters), 0, $length);
  }

  final public function getPasswordString($length = 8)
  {
    return $this->getRandomString($length, "abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ0123456789!@#$%^&*()_-=+;:,.?");
  }

  final function truncateString(string $text, int $maxLength = 10): string
  {
    if (mb_strlen($text, 'UTF-8') > $maxLength) {
      return mb_substr($text, 0, $maxLength, 'UTF-8') . "...";
    }
    return $text;
  }

  // byte값을 알아보기 쉽게 변환
  final public function getSizeForHuman($bytes)
  {
    $ext = array('B', 'KB', 'MB', 'GB', 'TB', 'PB', 'EB', 'ZB', 'YB');
    $unitCount = 0;
    for (; $bytes > 1024; $unitCount++) {
      $bytes /= 1024;
    }
    return floor($bytes) . $ext[$unitCount];
  }

  // Proxy등을 통하여 Client_IP가 알수없는경우 실제사용자의 IP를 가져오기 위한것
  final public function getClientIP($clientIP = false)
  {
    if (isset($_SERVER['HTTP_CLIENT_IP'])) {
      $clientIP = $_SERVER['HTTP_CLIENT_IP'];
    } else if (isset($_SERVER['HTTP_X_FORWARDED_FOR'])) {
      $clientIP = $_SERVER['HTTP_X_FORWARDED_FOR'];
    } else if (isset($_SERVER['HTTP_X_FORWARDED'])) {
      $clientIP = $_SERVER['HTTP_X_FORWARDED'];
    } else if (isset($_SERVER['HTTP_FORWARDED_FOR'])) {
      $clientIP = $_SERVER['HTTP_FORWARDED_FOR'];
    } else if (isset($_SERVER['HTTP_FORWARDED'])) {
      $clientIP = $_SERVER['HTTP_FORWARDED'];
    } else if (isset($_SERVER['REMOTE_ADDR'])) {
      $clientIP = $_SERVER['REMOTE_ADDR'];
    }
    return $clientIP;
  }

  final public function isDomain(string $domain): bool
  {
    $pattern_validation = '/((http|https)\:\/\/)?[a-zA-Z0-9\.\/\?\:@\-_=#]+\.([a-zA-Z0-9\&\.\/\?\:@\-_=#])*/';
    return preg_match($pattern_validation, $domain);
  }

  final public function isIPAddress(?string $ip = null, $type = 'ipv4'): bool
  {
    switch ($type) {
      case 'ipv4':
        $result = filter_var($ip, FILTER_VALIDATE_IP, FILTER_FLAG_IPV4);
        break;
      case 'ipv6':
        $result = filter_var($ip, FILTER_VALIDATE_IP, FILTER_FLAG_IPV6);
        break;
      case 'all':
        $result = filter_var($ip, FILTER_VALIDATE_IP);
        break;
      default:
        $result = filter_var($ip, FILTER_VALIDATE_IP, FILTER_FLAG_NO_PRIV_RANGE | FILTER_FLAG_NO_RES_RANGE);
        break;
    }
    return $result;
  }

  final public function isHost(string $host): bool
  {
    $pattern_validation = '/[a-zA-Z0-9\.\/\?\:@\*\-_=#]/';
    return preg_match($pattern_validation, $host);
  }

  // (EX:192.168.1.0 -> 192.168.001.000)
  final public function convertIPV4toCIDR($cidr)
  {
    $temps = explode(".", $cidr);
    return sprintf("%03d.%03d.%03d.%03d", $temps[0], $temps[1], $temps[2], $temps[3]);
  }

  // (EX:192.168.001.0000 -> 192.168.1.0)
  final public function convertCIDRtoIPV4($ipv4)
  {
    $temps = explode(".", $ipv4);
    return sprintf("%d.%d.%d.%d", $temps[0], $temps[1], $temps[2], $temps[3]);
  }

  final public function isMobile()
  {
    // Check the server headers to see if they're mobile friendly
    if (isset($_SERVER["HTTP_X_WAP_PROFILE"])) {
      return true;
    }
    // If the http_accept header supports wap then it's a mobile too
    if (preg_match("/wap\.|\.wap/i", $_SERVER["HTTP_ACCEPT"])) {
      return true;
    }
    // Still no luck? Let's have a look at the user agent on the browser. If it contains
    // any of the following, it's probably a mobile device. Kappow!
    if (isset($_SERVER["HTTP_USER_AGENT"])) {
      $user_agents = array("midp", "j2me", "avantg", "docomo", "novarra", "palmos", "palmsource", "240x320", "opwv", "chtml", "pda", "windows\ ce", "mmp\/", "blackberry", "mib\/", "symbian", "wireless", "nokia", "hand", "mobi", "phone", "cdm", "up\.b", "audio", "SIE\-", "SEC\-", "samsung", "HTC", "mot\-", "mitsu", "sagem", "sony", "alcatel", "lg", "erics", "vx", "NEC", "philips", "mmm", "xx", "panasonic", "sharp", "wap", "sch", "rover", "pocket", "benq", "java", "pt", "pg", "vox", "amoi", "bird", "compal", "kg", "voda", "sany", "kdd", "dbt", "sendo", "sgh", "gradi", "jb", "\d\d\di", "moto");
      foreach ($user_agents as $user_string) {
        if (preg_match("/" . $user_string . "/i", $_SERVER["HTTP_USER_AGENT"])) {
          return true;
        }
      }
    }
    // Let's NOT return "mobile" if it's an iPhone, because the iPhone can render normal pages quite well.
    if (preg_match("/iphone/i", $_SERVER["HTTP_USER_AGENT"])) {
      return false;
    }
    // None of the above? Then it's probably not a mobile device.
    return false;
  }
} //Class
